//
//  LameEncodeWrapper.m
//  LamePlugin
//
//  Created by tmkk on Sun Sep 21 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "LameEncodeWrapper.h"


@implementation LameEncodeWrapper

- (id)initWithFile:(char *)file
{
	[super init];
	filename = malloc(strlen(file)+1);
	strcpy(filename,file);
	lameflag = lame_init();
	return self;
}

- (int)setSampleNum:(int)num sampleRate:(int)freq channel:(int)ch quality:(int)q bitRate:(int)brate
{
	int ret;
	nsample = num;
	
	lame_set_num_samples(lameflag, num);
	lame_set_in_samplerate(lameflag, freq);
	lame_set_num_channels(lameflag, ch);
	lame_set_quality(lameflag, q);
	lame_set_brate(lameflag, brate);
	
	buffersize = (int)(num*(brate*1000/8)/freq + 4*576*(brate*1000/8)/freq + 256);
	mp3buffer = malloc((unsigned long)buffersize);
	
	ret = lame_init_params(lameflag);
	return ret;
}

- (int)startEncodeWithPCMBuffer:(short *)pcmBuf
{
	FILE *fp = fopen(filename,"wb");
	
	int ret = lame_encode_buffer(lameflag, pcmBuf, NULL, nsample, mp3buffer, buffersize);
	if (ret < 0) {
		if (ret == -1)
				fprintf(stderr, "mp3 buffer is not big enough... \n");
		else
				fprintf(stderr, "mp3 internal error:  error code=%i\n", ret);
		return ret;
	}
	fwrite(mp3buffer, 1, ret, fp);
	ret = lame_encode_flush(lameflag, mp3buffer, buffersize);
	if (ret < 0) {
		if (ret == -1)
				fprintf(stderr, "mp3 buffer is not big enough... \n");
		else
				fprintf(stderr, "mp3 internal error:  error code=%i\n", ret);
		return ret;
	}
	fwrite(mp3buffer, 1, ret, fp);
	fclose(fp);
	lame_close(lameflag);
	return 0;
}

- (void)dealloc
{
	if(filename) free(filename);
	if(mp3buffer) free(mp3buffer);
	
	[super dealloc];
}

@end
